
#make tdir default set in setrm method
if [ "$dea_setname" = "" ]; then
 if [ $choosemethod = setrm ]; then
   export dea_setname=tdir
 fi
fi

# get set name.
if ! preset setname; then
 rm -f sets

#get available set names
 for met in /etc/tbackup/*.set ; do 
  printf "`basename $met .set`\t" >>sets
  head -1 $met >>sets
 done

 echo
 echo "Available directory sets:"
 gawk "{  print NR, \"   \" \$0 }" sets

 while true; do
  printf "Enter set name or number "
  getpar setname

#print chosen set name in bla.
  gawk "( NR == \"$setname\" ) || ( \$1 == \"$setname\" ) { print \$1 }" \
    sets >bla

  re="`cat bla`"

  if [ "$re" != "" ]; then 
#necessary if chosen by number.
   export setname=$re
   break
  fi

  echo "No such directory set."
 done

 rm -f sets bla
fi

allpars setname
dea_rpars setname

export packhome=/
dea_rpars packhome

echo

source crunchset

lastfullv="<never>"
lastincv="<never>"
export lastfull=""
export lastinc=""

export now2=`expr \`date +%j\` + 365 \* \`date +%Y\``

if [ -e /etc/tbackup/$setname.log ]; then
 grep "^f " /etc/tbackup/$setname.log | tail -1 >bla
 if [ -s bla ]; then
  lastfull=`gawk "{ print \\\$2; }" bla`
  nowyy=`gawk "{ print \\\$3; }" bla`
  lastfullv=`gawk -F/ "{ print substr(\\\$2,2,100); }" bla`
  echo "The last full backup of $setname was made on $lastfullv,"
  echo "that was approx." `expr $now2 - $nowyy` "days ago."
  echo
 fi

 gawk -f- /etc/tbackup/$setname.log >bla <<-WUXTA
 BEGIN { i=""; }
 \$1 == "f" { i=""; }
 \$1 == "if" { i=\$0; }
 \$1 == "ii" { i=\$0; }
 END { if(i!="") print i; }
WUXTA
 if [ -s bla ]; then
  nowzz=`gawk "{ print \\\$3; }" bla`
  lastinc=`gawk "{ print \\\$2; }" bla`
  lastincv=`gawk -F/ "{ print substr(\\\$2,2,100); }" bla`
  echo "The last incremental backup of $setname was made on $lastincv,"
  echo "that was approx." `expr $now2 - $nowzz` "days ago."
  echo
 fi

fi

#always make a full backup of tdir.
if [ $setname = "tdir" ]; then 
export pre_level=f
fi

if ! preset level; then
 while true; do
  echo "Choose a backup level."
  echo " f  = full backup of all files"
  if [ "$lastfull" != "" ]; then
   echo " if = incremental backup of all files changed since last full backup"
  fi
  if [ "$lastinc" != "" ]; then
   echo " ii = incremental backup of all files changed since last incremental backup"
  fi
  getpar level
  if [ $level = "f" ]; then  
     ldes="Full"; break; fi
  if [ $level = "if" -a $lastfull != "" ]; then
     ldes="Incremental (on full)"; break; fi
  if [ $level = "ii" -a $lastinc != "" ]; then
     ldes="Incremental (on incr.)"; break; fi
 done
else
  if [ $level = "f"  ]; then  ldes="Full"; fi
  if [ $level = "if" ]; then  ldes="Incremental (on full)"; fi
  if [ $level = "ii" ]; then  ldes="Incremental (on incr.)"; fi
fi


allpars level
dea_rpars level

echo

echo "$ldes backup of directory set $setname." >descr
echo "(`head -1 /etc/tbackup/$setname.set`)" >>descr

if [ $level != "f" ]; then
 echo "Last full backup was on $lastfullv." >>descr
fi
if [ $level = "ii" ]; then
 echo "Last incremental backup was on $lastincv." >>descr
fi
echo "(Filenames in archive relative to $packhome)" >>descr

export now=`date "+%m%d%H%M%Y"`
export backupdate=$now
dea_rpars backupdate

export now2=`expr \`date +%j\` + 365 \* \`date +%Y\``
export nowv="`date`"

# all files newer than time file need to be written on an incremental backup.

if [ $level = "if" ]; then
 touch -t$lastfull timefile
fi

if [ $level = "ii" ]; then
 touch -t$lastinc timefile
fi


if [ $choosemethod = "setrm" ]; then
 if [ -s findtests ]; then
  echo "WARNING: The \`not' instructions in this directory set, i.e."
  printf "\007"
  grep "\bnot\b" /etc/tbackup/$setname.set | cat -n
  echo "exclude files and/or directories from the archive, but they do not exclude"
  echo "them from deletion."
  echo "The deletion phase of setrm removes ALL files and directories in the set, i.e."
  ls -x -d -w 70 `cat dirlist` | \
  gawk 'NR <= 8 {print "\t"$0;} NR==9 {print "Etc. (Only 8 lines shown.)"}'
  echo "and everything below, regardless of \`not' instructions."
  echo
  echo -n "Press ^C to abort, enter to continue."
  enter
 fi
fi
