/* 
sizes.c

read paths from stdin. Print total size of files in the path and total
number of paths.

For internal use by tguess.

AUTHOR
  Koen Holtman, koen@blade.stack.urc.tue.nl   (kh1994)

*/


#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>

void main(int argc, char ** argv)
{
  char name[1024];
  long tot,nr;
  struct stat fstatus;
 
  tot=nr=0;

  while(fgets(name,1024,stdin)!=NULL)
    {
     if(name[0]!='\0') name[strlen(name)-1]='\0';

     nr++;
     if(lstat(name,&fstatus)) { perror(name); continue; }
     if(S_ISREG(fstatus.st_mode))
       tot+=fstatus.st_size;
    }

  printf("%ld %ld\n",tot,nr);

}



